Index: doc/guide/magnetism/magnetism.rst
===================================================================
--- doc/guide/magnetism/magnetism.rst	(revision 4f5afc935845263676247d906df9688597dfda82)
+++ doc/guide/magnetism/magnetism.rst	(revision befe905ba1f75b9bc31808657037e4ea891bdf28)
@@ -39,8 +39,8 @@
 
 .. math::
-    -- &= ((1-u_i)(1-u_f))^{1/4} \\
-    -+ &= ((1-u_i)(u_f))^{1/4} \\
-    +- &= ((u_i)(1-u_f))^{1/4} \\
-    ++ &= ((u_i)(u_f))^{1/4}
+    -- &= (1-u_i)(1-u_f) \\
+    -+ &= (1-u_i)(u_f) \\
+    +- &= (u_i)(1-u_f) \\
+    ++ &= (u_i)(u_f)
 
 Ideally the experiment would measure the pure spin states independently and
@@ -104,2 +104,3 @@
 | 2015-05-02 Steve King
 | 2017-11-15 Paul Kienzle
+| 2018-06-02 Adam Washington
Index: doc/guide/plugin.rst
===================================================================
--- doc/guide/plugin.rst	(revision 7e6bc45eddf06819ea47d06f521d0c27c582996e)
+++ doc/guide/plugin.rst	(revision f796469ab131e5fc2424ecdfcd201846be55c8e1)
@@ -822,5 +822,5 @@
 
         :code:`source = ["lib/Si.c", ...]`
-        (`Si.c <https://github.com/SasView/sasmodels/tree/master/sasmodels/models/lib/Si.c>`_)
+        (`Si.c <https://github.com/SasView/sasmodels/tree/master/sasmodels/models/lib/sas_Si.c>`_)
 
     sas_3j1x_x(x):
Index: sasmodels/kernel_iq.c
===================================================================
--- sasmodels/kernel_iq.c	(revision dc6f601ca60f7d630a484562e056a94ed48bae82)
+++ sasmodels/kernel_iq.c	(revision 7c35fda803d68561ee8433f7c9355dcc9678049e)
@@ -83,11 +83,19 @@
   in_spin = clip(in_spin, 0.0, 1.0);
   out_spin = clip(out_spin, 0.0, 1.0);
-  // Note: sasview 3.1 scaled all slds by sqrt(weight) and assumed that
+  // Previous version of this function took the square root of the weights,
+  // under the assumption that 
+  //
   //     w*I(q, rho1, rho2, ...) = I(q, sqrt(w)*rho1, sqrt(w)*rho2, ...)
-  // which is likely to be the case for simple models.
-  weight[0] = sqrt((1.0-in_spin) * (1.0-out_spin)); // dd
-  weight[1] = sqrt((1.0-in_spin) * out_spin);       // du.real
-  weight[2] = sqrt(in_spin * (1.0-out_spin));       // ud.real
-  weight[3] = sqrt(in_spin * out_spin);             // uu
+  //
+  // However, since the weights are applied to the final intensity and
+  // are not interned inside the I(q) function, we want the full
+  // weight and not the square root.  Any function using
+  // set_spin_weights as part of calculating an amplitude will need to
+  // manually take that square root, but there is currently no such
+  // function.
+  weight[0] = (1.0-in_spin) * (1.0-out_spin); // dd
+  weight[1] = (1.0-in_spin) * out_spin;       // du
+  weight[2] = in_spin * (1.0-out_spin);       // ud
+  weight[3] = in_spin * out_spin;             // uu
   weight[4] = weight[1]; // du.imag
   weight[5] = weight[2]; // ud.imag
Index: sasmodels/models/mass_surface_fractal.py
===================================================================
--- sasmodels/models/mass_surface_fractal.py	(revision 2d81cfe3be42579d563407fb9275b7b516fee234)
+++ sasmodels/models/mass_surface_fractal.py	(revision 7994359d6c078cf35c29184c8eb57657f44ef374)
@@ -39,14 +39,25 @@
     The surface ( $D_s$ ) and mass ( $D_m$ ) fractal dimensions are only
     valid if $0 < surface\_dim < 6$ , $0 < mass\_dim < 6$ , and
-    $(surface\_dim + mass\_dim ) < 6$ .
-
+    $(surface\_dim + mass\_dim ) < 6$ . 
+    Older versions of sasview may have the default primary particle radius
+    larger than the cluster radius, this was an error, also present in the 
+    Schmidt review paper below. The primary particle should be the smaller 
+    as described in the original Hurd et.al. who also point out that 
+    polydispersity in the primary particle sizes may affect their 
+    apparent surface fractal dimension.
+    
 
 References
 ----------
 
-P Schmidt, *J Appl. Cryst.*, 24 (1991) 414-435 Equation(19)
+.. [#] P Schmidt, *J Appl. Cryst.*, 24 (1991) 414-435 Equation(19)
+.. [#] A J Hurd, D W Schaefer, J E Martin, *Phys. Rev. A*,
+   35 (1987) 2361-2364 Equation(2)
 
-A J Hurd, D W Schaefer, J E Martin, *Phys. Rev. A*,
-35 (1987) 2361-2364 Equation(2)
+Authorship and Verification
+----------------------------
+
+* **Converted to sasmodels by:** Piotr Rozyczko **Date:** Jan 20, 2016
+* **Last Reviewed by:** Richard Heenan **Date:** May 30, 2018
 """
 
@@ -67,5 +78,4 @@
         rg_primary    =  rg
         background   =  background
-        Ref: Schmidt, J Appl Cryst, eq(19), (1991), 24, 414-435
         Hurd, Schaefer, Martin, Phys Rev A, eq(2),(1987),35, 2361-2364
         Note that 0 < Ds< 6 and 0 < Dm < 6.
@@ -78,6 +88,6 @@
     ["fractal_dim_mass", "",      1.8, [0.0, 6.0], "", "Mass fractal dimension"],
     ["fractal_dim_surf", "",      2.3, [0.0, 6.0], "", "Surface fractal dimension"],
-    ["rg_cluster",       "Ang",  86.7, [0.0, inf], "", "Cluster radius of gyration"],
-    ["rg_primary",       "Ang", 4000., [0.0, inf], "", "Primary particle radius of gyration"],
+    ["rg_cluster",       "Ang", 4000., [0.0, inf], "", "Cluster radius of gyration"],
+    ["rg_primary",       "Ang",  86.7, [0.0, inf], "", "Primary particle radius of gyration"],
 ]
 # pylint: enable=bad-whitespace, line-too-long
@@ -107,11 +117,11 @@
             fractal_dim_mass=1.8,
             fractal_dim_surf=2.3,
-            rg_cluster=86.7,
-            rg_primary=4000.0)
+            rg_cluster=4000.0,
+            rg_primary=86.7)
 
 tests = [
 
-    # Accuracy tests based on content in test/utest_other_models.py
-    [{'fractal_dim_mass':      1.8,
+    # Accuracy tests based on content in test/utest_other_models.py  All except first, changed so rg_cluster is the larger, RKH 30 May 2018
+    [{'fractal_dim_mass':   1.8,
       'fractal_dim_surf':   2.3,
       'rg_cluster':   86.7,
@@ -123,21 +133,21 @@
     [{'fractal_dim_mass':      3.3,
       'fractal_dim_surf':   1.0,
-      'rg_cluster':   90.0,
-      'rg_primary': 4000.0,
-     }, 0.001, 0.18562699016],
+      'rg_cluster': 4000.0,
+      'rg_primary':   90.0,
+     }, 0.001, 0.0932516614456],
 
     [{'fractal_dim_mass':      1.3,
-      'fractal_dim_surf':   1.0,
-      'rg_cluster':   90.0,
-      'rg_primary': 2000.0,
+      'fractal_dim_surf':   2.0,
+      'rg_cluster': 2000.0,
+      'rg_primary':   90.0,
       'background':    0.8,
-     }, 0.001, 1.16539753641],
+     }, 0.001, 1.28296431786],
 
     [{'fractal_dim_mass':      2.3,
-      'fractal_dim_surf':   1.0,
-      'rg_cluster':   90.0,
-      'rg_primary': 1000.0,
+      'fractal_dim_surf':   3.1,
+      'rg_cluster':  1000.0,
+      'rg_primary':  30.0,
       'scale':        10.0,
       'background':    0.0,
-     }, 0.051, 0.000169548800377],
+     }, 0.051, 0.00333804044899],
     ]
